#pragma once

// Convert absolute time to relative offsets and insert continue events when events are too long.
void ConvertTimeToSampleDeltas(EvVec& events);
// Remove NOTE_OFF events if they are immediately followed by a NOTE_ON (even if the new note has a different pitch)
void RemoveRedundantOffEvents(EvVec& events);
// Turn E_NOTE_ON to E_NOTE_ON_LAST_VOL where possible. Also use 2 LSB for pan mask
void CompressNoteVolumeAndPan(EvVec& events);
// Compute sample offsets for notes and pitch bends. Must be called after prunning NOTE_OFF events
void ComputeSampleOffsets(EvVec& events);

// Unused:

// Approximate control values by a piece-wise linear function
//void LinearApproxEvents(CtrlVec& events);